@@@@@@@@@@@@@@@@@@@@@@@@ KEYS @@@@@@@@@@@@@@@@@@@@@@@@@@@  
  @ Your keyhandler code here
  @  r2 - Key scancode
  @       0x30 .. 0x39 - "0".."9"
  @       0x23 - "#"
  @       0x2a - "*"
  @  r1 - Event type (101h,106h,107h,...)
  @          0x106 - key pressed
  @          0x107 - key unpressed
  @        0x101 & scan 0x09 - RedButton pressed
  @        0x101 & scan 0x56 - CenterKey pressed
  @        0x101 & scan 0x08 - CenterKey holded
  @        0x101 & scan 0x07 - CenterKey unpressed
  @        0x101 & scan 0x0b - GreenButton pressed
  @        0x101 & scan 0x03 - JogUp
  @        0x101 & scan 0x05 - JogDown
  @        0x101 & scan 0x56 - JogPress
  @        0x101 & scan 0x4d - JogRelase
  @        0x101 & scan 0x0c - JogHold
  
.align 2
.Keys:
push  {r0-r6,lr}
mov r5,#0xf
and r1,r5



cmp r1,#0x06
bne end_control_key

cmp r2,#0x2a
beq buttton_star

bl .CheckStop
cmp r0,#1
beq end_control_key

bl .CheckPause
cmp r0,#1
beq end_control_key


cmp r2,#0x31
beq topleft
cmp r2,#0x33
beq topright
cmp r2,#0x34
beq bottomleft
cmp r2,#0x36
beq bottomright
b end_control_key

topleft:
	mov r0,#0
	bl .set_player_frame
	b end_control_key
topright:
	mov r0,#1
	bl .set_player_frame
	b end_control_key
bottomleft:
	mov r0,#2
	bl .set_player_frame
	b end_control_key
bottomright:
	mov r0,#3
	bl .set_player_frame
	b end_control_key
buttton_star:
	bl .switch_sound
	b end_control_key


end_control_key:

cmp r1,#0x01
bne end_key
cmp r2,#0x07
beq CenterButton
b end_key
@pause/next new game/continue game
CenterButton:
bl .CheckStop
cmp r0,#1
bne stop_next
bl .ClearStop
bl .Init_eggs
bl .get_game_over
cmp r0,#1
bne End_CButton
bl .next_game
b End_CButton
stop_next:
bl .CheckPause
cmp r0,#1
beq cb_clearpause
bl .SetPause
b End_CButton
cb_clearpause:
bl .ClearPause
End_CButton:
@b end_key

end_key:
pop   {r0-r6,pc}
@@@@@@@@@@@@@@@@@@@@@@@@ KEYS @@@@@@@@@@@@@@@@@@@@@@@@@@@  
