@@@@@@@@@@@@@@@@@@@@ get_score (->r0-score) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.get_score:
	ldr r0,score
	mov pc,lr

@@@@@@@@@@@@@@@@@@@@ set_score (r0-score) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.set_score:
push {r0-r1,lr}
	adr r1,score
	str r0,[r1]
pop  {r0-r1,pc}

@@@@@@@@@@@@@@@@@@@@ init_score @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.init_score:
push {r0-r1,lr}
	mov r0,#0
	bl .set_score
pop  {r0-r1,pc}

@@@@@@@@@@@@@@@@@@@@ add_score  @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.add_score:
push {r0,lr}
	bl .get_score
	add r0,#1
	bl .set_score
	bl .check_hi_score
pop  {r0,pc}

@@@@@@@@@@@@@@@@@@@@ check_HI_score (r0-score) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.check_hi_score:
push {r0-r2,lr}
	adr r2,HI_SCORE
	bl .get_score
	ldr r1,[r2]
	cmp r0,r1
	blt chs_no_save
	str r0,[r2]
chs_no_save	:
pop  {r0-r2,pc}

@@@@@@@@@@@@@@@@@@@@ get_score (->r0-score) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.get_hi_score:
	ldr r0,HI_SCORE
	mov pc,lr


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
score: 		.word 0
HI_SCORE:	.word 0




@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.draw_score:
push {r0-r5,lr}
bl .get_score
mov r2,r0
mov r0,#90
mov r5,r0
mov r1,#8
bl .blit_numbers
mov r2,#6
mul r0,r2
sub r5,r0
sub r5,#7
mov r0,r5
mov r3,#0
adr r2,sc
sub r1,#1
bl .Blit2bpp


bl .get_hi_score
mov r2,r0
mov r0,#90
mov r5,r0
mov r1,#1
bl .blit_numbers
mov r2,#6
mul r0,r2
sub r5,r0
sub r5,#6
mov r0,r5
mov r3,#0
adr r2,hi
sub r1,#1
bl .Blit2bpp
pop  {r0-r5,pc}

.align 2
hi: 
.byte 10,7  /* Image size*/
.byte 12,3,136,224,224,0,14,142,224,224,8,14,142,32,192,187,174,10
.align 2
sc: 
.byte 11,7  /* Image size*/
.byte 3,63,60,40,131,60,188,224,62,60,248,60,12,242,128,14,251,234,175,3

@@@@@@@@@@@@@@@@@@@@@@@@@ get,set_window_status @@@@@@@@@@@@@@@@@@@@@@@@@@2
.align 2
.get_window_status:
ldrb r0,window_status
mov pc,lr
.align 2
.set_window_status:
push {r0-r1,lr}
adr r1,window_status
strb r0,[r1]
pop  {r0-r1,pc}


@@@@@@@@@@@@@@@@@@@@@@@@@ change_window @@@@@@@@@@@@@@@@@@@@@@@@@@2
.align 2
.change_window:
push {r0,lr}
bl .get_window_status
cmp r0,#1
beq cw_end
mov r0,#2
cw_end:
sub r0,#1
bl .set_window_status
pop  {r0,pc}

@@@@@@@@@@@@@@@@@@@@@@@@ Draw_window
.align 2
.draw_window:
push {r0-r3,lr}
bl .get_window_status
adr r2,window_close
cmp r0,#0
beq dw_close
adr r2,window_open
dw_close:

mov r0,#15
mov r1,#0
mov r3,#0
bl .Blit4bpp @(posX,posY,bmpOffs,ofs)
pop  {r0-r3,pc}

.align 2
.work_window:
push {r0-r3,lr}
	adr r1,window_count
@	adr r3,must_incubation	
	ldr r2,window_time
	ldr r0,[r1]
	cmp r0,r2
	blt ww_add
	mov	r0,#0
	mov r2,#0
	bl .change_window 
	b ww_end
ww_add:
	add r0,#1
ww_end:
	str r0,[r1]
pop  {r0-r3,pc}

.Init_window:
push {r0-r1,lr}
	mov r0,#0
	bl .set_window_status
	adr r1,window_count
	ldrb r0,[r1]
pop  {r0-r1,pc}

.align 2
.equ len_win,221
.align 2
window_status: .byte 0 @ 0 - close
.align 2
window_time: .word 150 
.align 2
window_count: .word 0 

.align 2
/* format 4 bits per pixel */
window_open: 
.byte 21,21  /* Image size*/
.byte 2,0,34,34,34,34,34,34,2,0,2,51,3,0,0,0,0,0,0,51,3,48,0,3,68
.byte 68,68,68,4,3,48,0,3,50,64,68,68,68,68,48,2,3,48,32,3,68,68,68,68,4
.byte 35,48,0,3,52,64,68,68,68,68,48,3,3,48,64,3,68,68,68,68,4,51,48,0,3
.byte 52,64,68,68,68,68,48,3,3,48,32,3,68,68,68,68,4,35,48,0,3,50,64,68,68
.byte 68,68,48,2,3,48,32,3,68,68,68,68,4,35,48,0,3,50,64,68,68,68,68,48,2
.byte 3,48,32,3,68,68,68,68,4,35,48,0,3,52,64,68,68,68,68,48,3,3,48,32,3
.byte 68,68,68,68,4,35,48,0,3,50,64,68,68,68,68,48,2,3,48,64,3,68,68,68,68
.byte 4,51,48,0,3,50,64,68,68,68,68,48,2,3,48,0,3,68,68,68,68,4,3,48,0
.byte 51,3,0,0,0,0,0,0,51,3,2,0,34,34,34,34,34,34,2,0,2



.align 2
/* format 4 bits per pixel */

window_close: 
.byte 21,21  /* Image size*/
.byte 34,34,34,34,34,34,34,34,34,34,66,0,0,0,0,0,0,0,0,0,64,4,51,51,51
.byte 51,51,51,51,51,3,68,48,0,0,0,48,0,0,0,48,64,4,3,34,34,2,3,34,34
.byte 2,3,68,48,32,34,36,48,32,34,36,48,64,4,3,34,36,4,3,34,36,4,3,68,48
.byte 32,34,36,48,32,34,36,48,64,4,3,34,34,0,3,32,34,2,3,68,48,32,34,32,48
.byte 32,32,34,48,64,4,3,34,2,2,3,2,34,2,3,68,48,32,34,32,48,32,32,34,48
.byte 64,4,3,34,34,0,3,32,34,2,3,68,48,32,34,34,48,32,34,34,48,64,4,3,34
.byte 34,2,3,34,34,2,3,68,48,32,34,34,48,32,34,34,48,64,4,3,34,34,2,3,34
.byte 34,2,3,68,48,0,0,0,48,0,0,0,48,64,4,51,51,51,51,51,51,51,51,3,68
.byte 0,0,0,0,0,0,0,0,0,64,34,34,34,34,34,34,34,34,34,34,2





@@@@@@@@@@@@@@@@@@@@@@@@@ get,set_window_status @@@@@@@@@@@@@@@@@@@@@@@@@@2
.align 2
.get_face:
ldrb r0,face_status
mov pc,lr

.align 2
.set_face:
push {r0-r1,lr}
adr r1,face_status
strb r0,[r1]
pop  {r0-r1,pc}


@@@@@@@@@@@@@@@@@@@@@@@@@ change_face @@@@@@@@@@@@@@@@@@@@@@@@@@2
.align 2
.change_face:
push {r0,lr}
bl .get_face
cmp r0,#3
beq cf_zero
add r0,#1
b cf_end
cf_zero:
mov r0,#0
cf_end:
bl .set_face
pop  {r0,pc}

@@@@@@@@@@@@@@@@@@@@@@@@ Draw_face
.align 2
.draw_face:
push {r0-r3,lr}
bl .get_face
cmp r0,#0
beq df_face1
cmp r0,#1
beq df_face2
cmp r0,#2
beq df_face3
cmp r0,#3
beq df_face4
b df_con
df_face1:
adr r2,face1
b df_con
df_face2:
adr r2,face2
b df_con
df_face3:
adr r2,face3
b df_con
df_face4:
adr r2,face4
df_con:

mov r0,#19
mov r1,#4
mov r3,#0
bl .Blit2bpp @(posX,posY,bmpOffs,ofs)
pop  {r0-r3,pc}

.align 2
.work_face:
push {r0-r3,lr}
	adr r1,face_count
	ldr r2,face_time
	ldr r0,[r1]
	cmp r0,r2
	blt wf_add
	mov	r0,#0
	mov r2,#0
	bl .change_face 
	b wf_end
wf_add:
	add r0,#1
wf_end:
	str r0,[r1]
pop  {r0-r3,pc}





.align 2
face_status: .byte 0 @ 0 - close
.align 2
face_time: .word 5 
.align 2
face_count: .word 0 


.align 2
/* format 2 bits per pixel */
face1: 
.byte 15,15  /* Image size*/
.byte 255,255,255,255,255,0,252,255,15,0,252,255,0,0,252,63,34,34,255,131,170,10,255,40,203
.byte 202,63,170,169,242,143,106,170,252,143,169,201,255,160,149,194,63,160,42,176,255,160,194,235,127
.byte 85,245,250,85,85,149,2
.align 2
/* format 2 bits per pixel */
face2: 
.byte 15,15  /* Image size*/
.byte 255,255,255,255,255,255,255,255,255,255,255,255,255,0,252,255,15,0,252,255,0,0,252,63,34
.byte 34,255,131,170,10,255,40,203,202,63,170,169,242,143,106,170,252,143,169,201,255,160,149,194,63
.byte 160,42,240,255,160,194,3
.align 2
/* format 2 bits per pixel */
face3: 
.byte 15,15  /* Image size*/
.byte 255,255,255,255,255,255,255,255,255,255,255,255,0,252,255,15,0,252,255,0,0,252,63,34,34
.byte 255,131,170,10,255,40,203,202,63,170,169,242,143,106,170,252,143,169,201,255,160,149,194,43,160
.byte 42,176,250,160,194,175,2
.align 2
/* format 2 bits per pixel */
face4: 
.byte 15,15  /* Image size*/
.byte 15,0,252,255,0,0,252,63,34,34,255,131,170,10,255,40,203,202,63,170,169,242,143,106,170
.byte 252,143,169,201,255,160,149,194,43,160,42,176,250,160,194,175,126,85,245,171,85,85,213,107,85
.byte 85,213,85,85,85,117,1


@@@@@@@@@@@@@@@@@@@@@@@@@ SOUND WORK @@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@ get_sound (->r0-sound(0-off/1-on)) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.get_sound:
	ldrb r0,sound
	mov pc,lr
@@@@@@@@@@@@@@@@@@@@ set_sound (r0-sound(0-off/1-on)) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.set_sound:
push {r0-r1,lr}
	adr r1,sound
	strb r0,[r1]
pop  {r0-r1,pc}


@@@@@@@@@@@@@@@@@@@@ switch_sound @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.switch_sound:
push {r0,lr}
	bl .get_sound
	cmp r0,#1
	beq ss_no_sound
	add r0,#1
	b ss_end
ss_no_sound:
	sub r0,#1
ss_end:	
	bl .set_sound
pop  {r0,pc}

.draw_sound:
push {r0-r3,lr}
	bl .get_sound
	cmp r0,#0
	beq drawsound_no_put
	mov r0,#1
	mov r1,#84	
	adr r2,sound_key 
	mov r3,#0
	bl .Blit2bpp
drawsound_no_put:	
pop  {r0-r3,pc}

.align 2
sound: .byte 0

.align 2
/* format 2 bits per pixel */
sound_key: 
.byte 11,8  /* Image size*/
.byte 218,195,169,253,240,217,15,255,245,12,127,61,51,95,63,240,103,63,127,106,195,167

.align 2
.play_snd:
push {r0-r1,lr}
	mov r1,r0
	bl .get_sound
	cmp r0,#0
	beq snd_catch_egg_no_sound
	mov r0,r1
	bl .MelodyPlay
snd_catch_egg_no_sound:	
pop  {r0-r1,pc}


.align 2
.snd_catch_egg:
push {r0,lr}
	mov r0,#3
	bl .play_snd
pop  {r0,pc}

.align 2
.snd_egg_kill:
push {r0,lr}
	mov r0,#1
	bl .play_snd
pop  {r0,pc}


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@ break egges @@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@ get_de (->r0-dead egges) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.get_de:
	ldrb r0,dead_eggs
	mov pc,lr
@@@@@@@@@@@@@@@@@@@@ set_de (r0-dead egges) @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.set_de:
push {r0-r1,lr}
	adr r1,dead_eggs
	strb r0,[r1]
pop  {r0-r1,pc}
@@@@@@@@@@@@@@@@@@@@ get_game_over @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.get_game_over:
	ldrb r0,game_over
	mov pc,lr

@@@@@@@@@@@@@@@@@@@@ set_game_over @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.set_game_over:
push {r0-r1,lr}
	adr r1,game_over
	mov r0,#1
	strb r0,[r1]
pop  {r0-r1,pc}

@@@@@@@@@@@@@@@@@@@@ clear_game_over @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.clear_game_over:
push {r0-r1,lr}
	adr r1,game_over
	mov r0,#0
	strb r0,[r1]
pop  {r0-r1,pc}

@@@@@@@@@@@@@@@@@@@@ clear_de @@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.clear_de:
push {r0,lr}
	mov r0,#0
	bl .set_de
pop  {r0,pc}

@@@@@@@@@@@@@@@@@@@@ draw_de r0=x, r1=y, r2-part(0-empty 1-half 2-full) @@@@@@@@@@@@@@@@@@@@@@@@ 36 26
.draw_de:
push {r0-r3,lr}
	cmp r2,#0
	beq dd_end
	cmp r2,#1
	beq dd_half_egg
	adr r2,egg_dead_full
	b dd_con
dd_half_egg:	
	adr r2,egg_dead_half
dd_con:
	mov r3,#0
	bl .Blit2bpp
dd_end:	
pop  {r0-r3,pc}


.draw_des:
push {r0-r3,lr}
	bl .get_de
	mov r3,r0
	mov r0,#35	
	mov r1,#25		

dds_next:	

	cmp r3,#2
	ble dds_con
	sub r3,#2
	mov r2,#2
	bl .draw_de
	add r0,#9
	b dds_next
dds_con:	
	mov r2,r3
	bl .draw_de
pop  {r0-r3,pc}

.egg_crack:
push {r0-r3,lr}
	bl .get_de
	mov r3,r0
	bl .get_window_status
	cmp r0,#0
	bne egg_con
	add r3,#1
egg_con:
	add r3,#1
	cmp r3,#6
	blt egg_con2
	bl .set_game_over
egg_con2:	
	mov r0,r3
	bl .set_de
	
pop  {r0-r3,pc}





.align 2
dead_eggs: .byte 0
.align 2
game_over: .byte 0

.align 2
/* format 2 bits per pixel */
egg_dead_half: 
.byte 8,9  /* Image size*/
.byte 255,255,255,255,255,255,207,204,35,34,168,42,168,42,163,202,15,240

.align 2
/* format 2 bits per pixel */
egg_dead_full: 
.byte 8,9  /* Image size*/
.byte 63,252,143,242,163,203,163,206,168,42,168,42,168,42,163,202,15,240

