
.align 2
.GameSectionGet:push	{r0-r1,LR}
		ldr	r0,[r0,#0x68]
		adr	r1,game_section
		str	r0,[r1]
		pop	{r0-r1,PC}

.align 2
.Exit:
push {r0-r3,lr}
bl 	  .SaveGame
pop  {r0-r3,pc}

.align 2
.SaveGame:
push {r0-r7,lr}
 mov   r5,r0

  ldr   r6,game_section

  ldr   r0,prg_length
  bl    .malloc
  cmp   r0,#0
  beq   .write_score_end

  mov   r7,r0

  mov   r0,r6
  mov   r1,#1
  bl    .NVMGetSection
  mov   r4,r0
  ldr   r1,prg_length
  mov   r2,r7
  bl    .NVMReadSection
  mov   r0,r4
  bl    .NVMCloseSection
@ save hi score
  ldr   r0,hi_score_shift
  add   r0,r7
  push {r0}
  bl .get_hi_score
  mov   r1,r0
  pop  {r0}
  str   r1,[r0]
@ save hi score

  mov   r0,r6
  mov   r1,#2
  bl    .NVMGetSection
  mov   r4,r0
  ldr   r1,prg_length
  mov   r2,r7
  bl    .NVMWriteSection
  mov   r0,r4
  bl    .NVMCloseSection

  mov   r0,r7
  bl    .free

.write_score_end:
pop  {r0-r7,pc}

.align 2
game_section: 	.word 0
prg_length: 	.word program_end-program_start
hi_score_shift: .word HI_SCORE-program_start
