@@@@@@@@@@ get_egg_on_hen (r0-num of hen(0-4), r1-number of egg(0-6)->r0-value)@@@@@@@@@
.align 2
.get_egg_on_hen:
push {r1-r2,lr}
	cmp r0,#0
	beq geoh_0
	cmp r0,#1
	beq geoh_1
	cmp r0,#2
	beq geoh_2
	cmp r0,#3
	beq geoh_3
	b geoh_end
geoh_0:
	adr r2,hen0
	b geoh_continue
geoh_1:
	adr r2,hen1
	b geoh_continue
geoh_2:
	adr r2,hen2
	b geoh_continue
geoh_3:
	adr r2,hen3
	b geoh_continue
geoh_continue:
	ldrb r0,[r2,r1]
geoh_end:	
pop {r1-r2,pc}
@@@@@@@@@@ get_egg_on_hen (r0-num of hen, r1-number of egg->r0-value)@@@@@@@@@

@@@@@@@@@@ set_egg_on_hen (r0-num of hen(0-4), r1-number of egg(0-6),r2-value(0-1))@@@@@@@@@
.align 2
.set_egg_on_hen:
push {r0-r3,lr}
	mov r3,r2
	cmp r0,#0
	beq seoh_0
	cmp r0,#1
	beq seoh_1
	cmp r0,#2
	beq seoh_2
	cmp r0,#3
	beq seoh_3
	b seoh_end
seoh_0:
	adr r2,hen0
	b seoh_continue
seoh_1:
	adr r2,hen1
	b seoh_continue
seoh_2:
	adr r2,hen2
	b seoh_continue
seoh_3:
	adr r2,hen3
	b seoh_continue
seoh_continue:
	strb r3,[r2,r1]
seoh_end:	
pop {r0-r3,pc}

@@@@@@@@@@ set_egg_on_hen (r0-num of hen(0-4), r1-number of egg(0-6),r2-value(0-1) @@@@@@@@@



@@@@@@@@@@ egges @@@@@@@@@
.align 2
hen0: .byte 0,0,0,0,0,0,0
.align 2
hen1: .byte 0,0,0,0,0,0,0
.align 2
hen2: .byte 0,0,0,0,0,0,0
.align 2
hen3: .byte 0,0,0,0,0,0,0
@@@@@@@@@@@@@@@ add_egg (r0-num of hen) @@@@@@@@@@@@@@@@
.align 2
.add_egg:
push {r0-r3,lr}
	mov r3,#0
add_egg_begin:
	mov r1,#0
	bl .get_egg_on_hen
	cmp r0,#1
	bne add_egg_add
	add r3,#1
	cmp r3,#3
	beq add_egg_end
	cmp r0,#3
	beq add_egg_noadd
	add r0,#1
	b add_egg_begin
add_egg_noadd:
	mov r0,#0
	b add_egg_begin
add_egg_add:
	mov r1,#0
	mov r2,#1
	bl .set_egg_on_hen

add_egg_end:
pop  {r0-r3,pc}

@@@@@@@@@@@@@@@ add_egg (r0-num of hen) @@@@@@@@@@@@@@@@
.align 2
.add_egg1:
push {r0-r3,lr}
	mov r1,#0
	mov r2,#1
	bl .set_egg_on_hen
pop  {r0-r3,pc}


@@@@@@@@@@@ Incubation @@@@@@@@@@@@@@@@@@
.align 2
.Incubation:
push {r0,lr}
 mov r0,#4
 bl .Random
 bl .add_egg1
pop  {r0,pc}

@@@@@@@@@ egg_step r0-hen, @@@@@@@@@@@@@@@@@@@@@@
.align 2
.egg_step:
push {r1-r7,lr}
	mov r5,r0
	mov r1,#5
egg_step_next:
	mov r0,r5
	bl .get_egg_on_hen
	mov r4,r0
	mov r2,#0
	mov r0,r5
	bl .set_egg_on_hen
	mov r2,r4
	add r1,#1 
	bl .set_egg_on_hen
	sub r1,#2
	cmp r1,#0
	bne egg_step_next 

	mov r0,r5
	bl .get_egg_on_hen
	mov r4,r0
	mov r2,#0
	mov r0,r5
	bl .set_egg_on_hen
	mov r2,r4
	add r1,#1
	bl .set_egg_on_hen

	mov r1,#6
	mov r5,r0
	bl .get_egg_on_hen
@	mov r3,r0
	cmp r0,#1
	bne step_egg_end
	bl .get_player_frame
	cmp r0,r5
	bne step_egg_end
	mov r2,#0
	bl .set_egg_on_hen
	bl .add_score
	bl .snd_catch_egg
	bl .cycle_clear_counter
	bl .cycle_speed_counter
	bl .cycle_inc_incubation
step_egg_end:
	mov r0,r5
	mov r1,#6
	bl .get_egg_on_hen
pop  {r1-r7,pc}


@@@@@@@@@ egg_cycle @@@@@@@@@@@@@@@@@@@@@@
.align 2
.egg_cycle:
push {r0,lr}
bl .get_takt
bl .egg_step
cmp r0,#0
 beq egg_cycle_end
 bl .snd_egg_kill
 bl .egg_crack
 bl .SetStop
egg_cycle_end:

b ec_end

ec_end:


pop  {r0,pc}



@@@@@@@@@@ get_XY_egg (r0-num of hen(0-4), r1-number of egg(0-6)->r0-X r1-Y r2 -type @@@@@@@@@
.align 2
.get_XY_egg:
push {r3-r6,lr}
	mov r6,r1
	cmp r0,#0
	beq gxye_0
	cmp r0,#1
	beq gxye_1
	cmp r0,#2
	beq gxye_2
	cmp r0,#3
	beq gxye_3
	b gxye_end
gxye_0:
	adr r3,hen0_X
	adr r4,hen0_Y
	adr r5,hen0_type
	b gxye_continue
gxye_1:
	adr r3,hen1_X
	adr r4,hen1_Y
	adr r5,hen1_type	
	b gxye_continue
gxye_2:
	adr r3,hen2_X
	adr r4,hen2_Y
	adr r5,hen2_type	
	b gxye_continue
gxye_3:
	adr r3,hen3_X
	adr r4,hen3_Y
	adr r5,hen3_type	
	b gxye_continue
gxye_continue:
	ldrb r0,[r3,r6]
	ldrb r1,[r4,r6]	
	ldrb r2,[r5,r6]	
gxye_end:	
pop {r3-r6,pc}
@@@@@@@@@@ get_XY_egg (r0-num of hen(0-4), r1-number of egg(0-6)->r0-X r1-Y r2 -type@@@@@@@@@
@@@@@@@@@@ Init_eggs @@@@@@@@@
.align 2
.Init_eggs:
push {r0-r3,lr}
	mov r0,#0
	mov r1,#0
	mov r2,#0
ie_next:
	bl .set_egg_on_hen
	add r1,#1
	cmp r1,#7
	bne ie_next
	mov r1,#0
	add r0,#1
	cmp r0,#4
	bne ie_next
pop  {r0-r3,pc}

@@@@@ Coordinates of egges @@@@@
@topleft
.align 2
hen0_X: .byte 7,12,17,22,27,32,31
.align 2
hen0_Y: .byte 29,31,33,35,37,40,79
@topright
.align 2
hen1_X: .byte 86,81,76,71,66,61,58
.align 2
hen1_Y: .byte 29,31,33,35,37,40,79
@bottomleft
.align 2
hen2_X: .byte 4,9,14,19,24,29,26
.align 2
hen2_Y: .byte 54,56,58,60,62,65,79
@bottomright
.align 2
hen3_X: .byte 89,84,79,74,69,64,60
.align 2
hen3_Y: .byte 54,56,58,60,62,65,79
@@@@@@@@@@ types of egges @@@@@@@@@
.align 2
hen0_type: .byte 0,1,0,1,0,1,2
.align 2
hen1_type: .byte 1,0,1,0,1,0,2
.align 2
hen2_type: .byte 0,1,0,1,0,1,2
.align 2
hen3_type: .byte 1,0,1,0,1,0,2


