@@@@@@@ Blit1bpp @(r0-posX,r1-posY,r2-bmpOffs,r3-ofs,r4-color1,r5-color2 (colors1-4,4-transparent))@@@@@@@@@@@@@@@@@@
.align 2
.Blit1bpp: 			
  push  {r0-r7,lr}
  adr r7,color1
  strb r4,[r7] @save color1
  adr r7,color2  
  strb r5,[r7] @save color2
  
  add   r5,r2,#2
  add   r5,r3 @ pointer on bitmap data
  ldrb  r3,[r2] @Width 
  ldrb  r4,[r2,#1] @Height
  mov   r7,r3 @Width

  bl    .getofs

  mov   r6,#8 @num pixels in byte
  ldrb  r1,[r5]

.blit1bpp_loop:
  mov   r2,#1 @move 1
  and   r2,r1 @ and with data byte 
  lsr   r1,#1 @ shift right on 1 to next value
  
  cmp r2,#0
  beq .blit1bpp_00  @if first color
  cmp r2,#1
  beq .blit1bpp_11  @if second color
  
.blit1bpp_00:
  ldrb r2,color1
  b .blit1bpp_even

.blit1bpp_11:  
  ldrb r2,color2
  b .blit1bpp_even

.blit1bpp_even:  
  cmp r2,#4
  beq .blit1bpp_no_put
  strb  r2,[r0] @
.blit1bpp_no_put:
  add   r0,#1

  sub   r6,#1
  bne   .blit1bpp_1
  mov   r6,#8
  add   r5,#1
  ldrb  r1,[r5]
.blit1bpp_1:
  
  sub   r3,#1
  bne   .blit1bpp_loop
  mov   r3,r7
  add   r0,#96
  sub   r0,r7

  sub   r4,#1
  bne   .blit1bpp_loop

  pop   {r0-r7,pc}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
color1: .byte 0
.align 2
color2: .byte 3
@@@@@@@ Blit1bpp @(r0-posX,r1-posY,r2-bmpOffs,r3-ofs,r4-color1,r5-color2 (colors1-4,4-transparent))@@@@@@@@@@@@@@@@@@



@@@@@@@ Blit2bpp @(posX,posY,bmpOffs,ofs) @@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.Blit2bpp: 			
  push  {r0-r7,lr}

  add   r5,r2,#2
  add   r5,r3
  ldrb  r3,[r2]
  ldrb  r4,[r2,#1]
  mov   r7,r3
  
  bl    .getofs

  mov   r6,#4
  ldrb  r1,[r5]

.blit2bpp_loop:
  mov   r2,#3
  and   r2,r1
  lsr   r1,#2
  strb  r2,[r0]
  add   r0,#1

  sub   r6,#1
  bne   .blit2bpp_1
  mov   r6,#4
  add   r5,#1
  ldrb  r1,[r5]
.blit2bpp_1:
  
  sub   r3,#1
  bne   .blit2bpp_loop
  mov   r3,r7
  add   r0,#96
  sub   r0,r7

  sub   r4,#1
  bne   .blit2bpp_loop

  pop   {r0-r7,pc}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@ Blit4bpp @(posX,posY,bmpOffs,ofs) @@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.Blit4bpp: 			
  push  {r0-r7,lr}

  add   r5,r2,#2
  add   r5,r3 @r5-real bitmap offset
  ldrb  r3,[r2] @r3-x
  ldrb  r4,[r2,#1] @r4-y
  mov   r7,r3 @r7-x

  bl    .getofs

  mov   r6,#2
  ldrb  r1,[r5]

.blit4bpp_loop:
  mov   r2,#15
  and   r2,r1
  lsr   r1,#4
  cmp 	r2,#4
  beq 	.blit4bpp_no_put
  strb  r2,[r0]
.blit4bpp_no_put:
  add   r0,#1

  sub   r6,#1
  bne   .blit4bpp_1
  mov   r6,#2
  add   r5,#1
  ldrb  r1,[r5]
.blit4bpp_1:
  
  sub   r3,#1
  bne   .blit4bpp_loop
  mov   r3,r7
  add   r0,#96
  sub   r0,r7

  sub   r4,#1
  bne   .blit4bpp_loop

  pop   {r0-r7,pc}

@@@@@@@ Blit_numbers @(posX,posY,number) @@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.blit_numbers: 			
  push  {r1-r7,lr}
  	mov r6,r0
  	mov r7,r1
	mov r5,#0
  	mov r0,r2
bm_next_num:
  	mov r1,#10
  	bl .divmod
	
	push {r0-r5}
	adr r2,numbers2
	
	mov r3,#4
	mul r3,r1
	
	mov r0,r6
	mov r1,r7
	mov r4,#2
	mov r5,#3
	bl .Blit1bpp
	sub r0,#1
	sub r1,#1
	mov r4,#0
	mov r5,#4
	bl .Blit1bpp	
	sub r6,#len
  	pop  {r0-r5}
    add r5,#1
    
  	cmp r0,#0
  	bne bm_next_num
  
    mov r0,r5
  pop   {r1-r7,pc}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.equ len,6  
.equ _num,4  
.align 2
numbers: 
.byte 5,6
.byte 209,57,231,34
.byte 119,214,123,47
.byte 209,189,232,1
.byte 209,205,231,34
.byte 171,57,240,30
.byte 192,195,231,34
.byte 209,75,230,34
.byte 192,221,189,55
.byte 209,69,231,34
.byte 209,153,244,34
.align 2
numbers2: 
.byte 5,6
.byte 209,24,99,34
.byte 119,198,57,39
.byte 209,156,200,1
.byte 209,204,99,34
.byte 163,24,112,14
.byte 192,195,99,34
.byte 209,75,98,34
.byte 192,157,57,39
.byte 209,68,99,34
.byte 145,145,244,34

@@@@@@@@@@@@@@@ increase_adr[W/B] (r0-adr,r1-adr whith max count-r0-value(0-if add,1 -if zero))@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.increase_adrW:
push {r1-r4,lr}
	ldr r2,[r0]
	ldr r3,[r1]

	cmp r2,r3
	blt increase_adrW_add
	mov r2,#1
	mov r4,#1
	b increase_adrW_end
increase_adrW_add:
	add r2,#1
	mov r4,#0
increase_adrW_end:
	str r2,[r0]
	mov r0,r4
pop  {r1-r4,pc}

.align 2
.increase_adrB:
push {r1-r4,lr}
	ldrb r2,[r0]
	ldrb r3,[r1]

	cmp r2,r3
	blt increase_adrB_add
	mov r2,#1
	mov r4,#1
	b increase_adrB_end
increase_adrB_add:
	add r2,#1
	mov r4,#0
increase_adrB_end:
	strb r2,[r0]
	mov r0,r4
pop  {r1-r4,pc}
@@@@@@@@@@@@@@@ increase_adr[W/B] (r0-adr,r1-adr whith max count-r0-value(0-if add,1 -if zero))@@@@@@@@@@@@@@@@@@@@@@@
