@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.add_incubation:
push {r0,lr}
	bl .get_speed_of_incubation
	cmp r0,#4
	ble ai_4
	sub r0,#2
	b ai_end
ai_4:	
	mov r0,#4
ai_end:
	bl .set_speed_of_incubation
pop  {r0,pc}

.align 2
.clear_incubation:
push {r0-r2,lr}
	bl .get_score
	mov r1,#100
	bl .divmod
	mov r2,#18
	sub r0,r2,r0
	bl .set_speed_of_incubation
pop  {r0-r2,pc}


.align 2
.set_speed_of_incubation:
push {r0-r1,lr}
	adr r1,speed_of_incubation
	strb r0,[r1]
pop  {r0-r1,pc}

.align 2
.get_speed_of_incubation:
push {r1,lr}
	adr r1,speed_of_incubation
	ldrb r0,[r1]
pop  {r1,pc}

.align 2
.check_incubation:
push {r1,lr}
	adr r1,speed_of_incubation
	ldrb r0,[r1]
pop  {r1,pc}

.align 2
.incubation_work:
push {r0-r3,lr}
	adr r1,counter_of_incubation
	adr r3,must_incubation	
	ldrb r2,speed_of_incubation
	ldrb r0,[r1]
	cmp r0,r2
	blt iw_add
	mov	r0,#0
	mov r2,#1
	bl .Incubation
	b iw_end
iw_add:
	add r0,#1
	mov r2,#0

iw_end:
	strb r0,[r1]
	strb r2,[r3]
pop  {r0-r3,pc}

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
speed_of_incubation: .byte 17
.align 2
counter_of_incubation: .byte 0
.align 2
must_incubation: .byte 0



@@@@@@@@@@@@get speed(->r0-speed)@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.get_speed:
push {r1-r2,lr}
	adr r1,speed
	ldrb r0,[r1]
	mov r0,r2
pop  {r1-r2,pc}
@@@@@@@@@@@@set speed(r0-new speed)@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.set_speed:
push {r0-r2,lr}
	adr r2,speed
	strb r0,[r2]
pop  {r0-r2,pc}

@@@@@@@@@@@@ speed_work @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.speed_work:
push {r0-r3,lr}
	adr r1,count_speed
@	adr r3,must_incubation	
	ldrb r2,speed
	ldrb r0,[r1]
	cmp r0,r2
	blt sw_add
	mov	r0,#0
	mov r2,#0
	bl .takt_work 	
	b sw_end
sw_add:
	add r0,#1
sw_end:
	strb r0,[r1]
pop  {r0-r3,pc}

@@@@@@@@@@@@get takt(->r0-speed)@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.get_takt:
push {r1,lr}
	adr r1,takt
	ldrb r0,[r1]
pop  {r1,pc}
@@@@@@@@@@@@set takt(r0-takt)@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.set_takt:
push {r0-r1,lr}
	adr r1,takt
	strb r0,[r1]
pop  {r0-r1,pc}
@@@@@@@@@@@@ takt_work @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.takt_work:
push {r0-r1,lr}
	adr r1,takt
	ldrb r0,[r1]
	cmp r0,#3
	blt tw_add
	mov	r0,#0
	b tw_end
tw_add:
	add r0,#1
tw_end:
	strb r0,[r1]
bl .egg_cycle	
pop  {r0-r1,pc}


.align 2
speed: .byte 0
.align 2
count_speed: .byte 0

.align 2
takt: 	.byte 1


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.SetPause:
push {r0-r1,lr}
adr r0,pause
mov r1,#1
strb r1,[r0]
pop  {r0-r1,pc}

.align 2
.ClearPause:
push {r0-r1,lr}
adr r0,pause
mov r1,#0
strb r1,[r0]
pop  {r0-r1,pc}
.align 2
.CheckPause:
ldrb r0,pause
mov pc,lr

.align 2
.draw_pause:
push {r0-r3,lr}
	bl .CheckPause
	cmp r0,#0
	beq drawpause_no_put
	mov r0,#13
	mov r1,#84	
	adr r2,pause_bmp 
	mov r3,#0
	bl .Blit2bpp
drawpause_no_put:	
pop  {r0-r3,pc}


.align 2
pause: .byte 0

.align 2
/* format 2 bits per pixel */
pause_bmp: 
.byte 30,8  /* Image size*/
.byte 218,255,255,255,255,255,127,106,3,255,48,207,195,3,156,61,207,51,243,204,51,255,215,243,204
.byte 51,207,243,3,127,61,240,0,243,252,60,255,215,243,207,51,207,60,243,127,54,255,60,15,63
.byte 60,192,169,253,255,255,255,255,255,167


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.SetStop:
push {r0-r1,lr}
adr r0,stop
mov r1,#1
strb r1,[r0]
pop  {r0-r1,pc}

.align 2
.ClearStop:
push {r0-r1,lr}
adr r0,stop
mov r1,#0
strb r1,[r0]
pop  {r0-r1,pc}

.align 2
.CheckStop:
ldrb r0,stop
mov pc,lr

.align 2
.draw_gover:
push {r0-r3,lr}
	bl .get_game_over
	cmp r0,#0
	beq drawgover_no_put
	mov r0,#46
	mov r1,#84	
	adr r2,gover 
	mov r3,#0
	bl .Blit2bpp
drawgover_no_put:	
pop  {r0-r3,pc}



.align 2
stop: .byte 0

.align 2
/* format 2 bits per pixel */
gover: 
.byte 50,8  /* Image size*/
.byte 218,255,255,255,255,255,255,255,255,255,255,127,106,15,255,48,63,3,252,195,243,51,192,192,159
.byte 61,207,51,195,48,255,207,51,63,243,207,243,215,243,207,51,51,3,255,60,243,51,240,60,127
.byte 61,195,0,243,51,255,207,243,204,243,15,252,215,243,204,51,63,243,255,60,207,60,255,60,127
.byte 246,240,60,243,51,192,63,252,243,3,204,243,169,253,255,255,255,255,255,255,255,255,255,255,167


@@@@@@@@@@@@@@@@counters@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.cycle_speed_counter:
push {r0-r2,lr}
adr r0,inc_speed_counter
adr r1,inc_speed
bl .increase_adrW
cmp r0,#1
bne add_speed_counter_end
@ add code for increase speed
bl .clear_incubation
add_speed_counter_end:
pop  {r0-r2,pc}

.align 2
inc_speed_counter: .word 0
.align 2
inc_speed: .word 100
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
.align 2
.cycle_clear_counter:
push {r0-r2,lr}
adr r0,clear_counter
adr r1,clear_freq
bl .increase_adrW
cmp r0,#1
bne cycle_clear_counter_end
@ add code for clear eggs
	bl .Init_eggs
	bl .clear_de
cycle_clear_counter_end:
pop  {r0-r2,pc}

.align 2
clear_counter: .word 1
.align 2
clear_freq: .word 200
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

.align 2
.cycle_inc_incubation:
push {r0-r2,lr}
adr r0,incubation_counter
adr r1,incubation_freq
bl .increase_adrW
cmp r0,#1
bne cycle_inc_incubation_end
@ add code for increase inkubation frequency
bl .add_incubation
cycle_inc_incubation_end:
pop  {r0-r2,pc}

.align 2
incubation_counter: .word 1
.align 2
incubation_freq: .word 10
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
